<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
</head>
<body>
<?php

$search = "immobilier"; // recherche youtube : immobilier, immobilier paris, banque finance,...
$content_length = 500; // longueur minimume de contenu désirée en nombre de caractères

$useragent = "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.11 (KHTML, like Gecko) Chrome/23.0.1271.95 Safari/537.11";
$referer = "http://www.youtube.com/";

if (file_exists("cache/".md5(currentUrl()).".txt") && filesize("cache/".md5(currentUrl()).".txt") > $content_length) {
    $fh = fopen("cache/".md5(currentUrl()).".txt", 'r');
    $content = fread($fh, filesize("cache/".md5(currentUrl()).".txt"));
	fclose($fh);
	echo $content;
}else {	
	$content = "";	
	while(strlen($content) < $content_length) {
		// array des vidéos
		$search_result = getVideos($search, $useragent, $referer);
		$content .= getTranscripts($search_result, $useragent, $referer);
	}
	$fh = fopen("cache/".md5(currentUrl()).".txt", 'w') or die("Pb avec le fichier");
	fwrite($fh, $content);
	fclose($fh);
	echo $content;	
}

/*
	FONCTIONS
*/
function getVideos($search, $useragent, $referer) {
	// max 1000 resultats par requete soit 50 pages de 20 résultats
	$res = scrap("http://www.youtube.com/results?search_type=videos&search_query=".urlencode($search)."&page=".rand(1,50), $useragent, $referer);
	$html = new DOMDocument();
	@$html->loadHTML($res);
	$xpath = new DOMXPath( $html );

	$aTag = $xpath->query("//*[@id='search-results']/li/div/h3/a");
	$finaloutput = array();
	foreach($aTag as $url){
		$finaloutput[str_replace('/watch?v=', '', $url->getAttribute('href'))] = utf8_decode($url->nodeValue);
	}
	return $finaloutput;
}

function scrap($url, $useragent, $referer) {
	$ch = curl_init($url);
	curl_setopt($ch, CURLOPT_USERAGENT, $useragent);
	curl_setopt($ch, CURLOPT_REFERER, $referer);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
	$result = curl_exec($ch);
	curl_close($ch);
	return $result;
}

function cleanTranscript($script) {
	return str_replace("\n", ' ', rtrim(strip_tags($script)));
}

function currentUrl() {
	return $_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
}

function getTranscripts($nodes, $useragent, $referer){
	set_time_limit(90);

	$curl_arr = array();
	$master = curl_multi_init();
	$i = 0;

	foreach($nodes as $key => $value) {
        $curl_arr[$i] = curl_init("http://www.youtube.com/api/timedtext?lang=fr&format=1&kind=&hl=fr&type=track&v=".$key);
        curl_setopt($curl_arr[$i], CURLOPT_FOLLOWLOCATION, true);
	    curl_setopt($curl_arr[$i], CURLOPT_USERAGENT, $useragent);
        curl_setopt($curl_arr[$i], CURLOPT_FRESH_CONNECT,true);
        curl_setopt($curl_arr[$i], CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($curl_arr[$i], CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl_arr[$i], CURLOPT_REFERER, $referer);
        curl_setopt($curl_arr[$i], CURLOPT_TIMEOUT, 30);

       curl_multi_add_handle($master, $curl_arr[$i]);
	   $i++;
	}

	$previousActive = -1;
	$finalresult = array();
	$returnedOrder = array();
	do {
		curl_multi_exec($master, $running);
		if($running !== $previousActive){
			$info = curl_multi_info_read($master);
			if($info['handle']){
				$finalresult[] = cleanTranscript(html_entity_decode(curl_multi_getcontent($info['handle'])));
				$returnedOrder[] = array_search($info['handle'], $curl_arr, true);
				curl_multi_remove_handle($master, $info['handle']);
				curl_close($curl_arr[end($returnedOrder)]);
				ob_flush();flush();
			}
		}
		$previousActive = $running;
	} while($running > 0);

	curl_multi_close($master);
	
	$res = "";
	foreach($finalresult as $fr) {
		$res .= $fr . " ";
	}

	set_time_limit(30);
	return $res;
}
/*
	FIN FONCTIONS
*/

?>
</body>
</html>